class Bullet {
  float x, y, angle, velocity;
  Bullet(float _x, float _y, float _angle, float _velocity) {
    x = _x; 
    y = _y; 
    angle = _angle; 
    velocity = _velocity;
  }
  void display() {
    pushMatrix();
    translate(x, y);
    noStroke();
    ellipse(0, 0, 3, 3);
    popMatrix();
  }
  void mechanics() {
    x += sin (angle) * velocity;
    y += cos (angle) * velocity;
  }
}

class Missile {
  float x, y, angle, velocity;
  Missile(float _x, float _y, float _angle, float _velocity) {
    x = _x; 
    y = _y; 
    angle = _angle; 
    velocity = _velocity;
  }
  void display() {
    pushMatrix();
    translate(x, y);
    noStroke();
    fill(255);
    rect(0, 0, 13, 13);
    popMatrix();
  } 
  void mechanics() {
    float targetX = -1000, targetY = -1000;
    int closestTargetId = -1;
    for (int i = 0; i < asteroids.size(); ++i) {
      if (dist(asteroids.get(i).x, asteroids.get(i).y, x, y) < dist(targetX, targetY, x, y)) {
        targetX = asteroids.get(i).x;
        targetY = asteroids.get(i).y;
        closestTargetId = i;
      }
    }
    if (closestTargetId != -1) {
      /*targetX = 1000;
      targetY = -1000;*/
      float newAng = atan2(y - targetY, x - targetX);
      newAng += PI;
      if(newAng >= angle) angle += 0.1;
      else angle -= 0.1;
      angle %= 2 * PI;
    }
    x += cos (angle) * velocity;
    y += sin (angle) * velocity;
  }
}